---
title: "Create Source"
slug: "create-source"
updated: 2025-06-30T12:22:12Z
published: 2025-06-30T12:22:12Z
canonical: "docs.plainid.io/create-source"
---
> ## Documentation Index
> Fetch the complete documentation index at: https://docs.plainid.io/llms.txt
> Use this file to discover all available pages before exploring further.
# Create Source
Post/api/1.0/paa-groups/{envId}/{paaGroupId}/sources
This API is designed to create a Source within a specified PAA Group.
## Notice
Accessing the APIs is through a dedicated domain/URL, according to your PlainID Tenant Location**United States (US)** - `https://API.us1.plainid.io`**Canada (CA)** - `https://api.ca1.plainid.io`**Europe (EU)** - `https://api.eu1.plainid.io`
## Using HTML Encoded Special Characters
Use HTML encoded patterns when working with values that contain special characters like spaces, dashes, etc. Refer to this [HTML URL Encoding Reference](https://www.w3schools.com/tags/ref_urlencode.ASP) for a full list.
### Important note about headers
Refer to the headers below to modify your cURL sample. Check if the following headers are in the sample, if not, ensure you add it to your cURL sample before pasting into your API tool.
#### Headers
*Required
| Header | Value | cURL Line |
| --- | --- | --- |
| Accept | `application/json` | `-H"Accept: application/json"` |
| Content Type | `application/json` | `-H"Content-Type: application/json"` |
### cURL Sample Guidelines
In order for the relevant parameters to appear in the cURL sample, you can input the values in the interactive API console on the right. They will then appear in the cURL sample on the bottom of the page in the correct format.
### Using HTML Encoded Special Characters
Use HTML encoded patterns when working with values that contain special characters like spaces, dashes, etc. Refer to this [HTML URL Encoding Reference](https://www.w3schools.com/tags/ref_urlencode.ASP) for a full list.
'
SecurityHTTPType bearer
For more details about Administration API Authentication, check out the Authentication APIs documentation Provide your bearer token in the Authorization header when making requests to protected resources. Example: `Authorization: Bearer 123`
Path parametersenvIdstring (uuid) Required
The Environment ID can be found under the Details Tab in the Environment Settings.
paaGroupIdstringRequired
The PAA Group Id
Body parameters
The Source Request Body
example
```json
{
"paaGroupId": "paa1",
"adapter": "ws",
"name": "mockrest2",
"status": "ACTIVE",
"description": "",
"properties": {},
"translator": {
"name": "plainid-rest-iRo",
"type": "plainid-rest",
"properties": {
"supportsfilter": true
}
},
"models": [
{
"type": "PHYSICAL",
"paaGroupId": "paa1",
"visible": true,
"name": "mockrest",
"description": "",
"properties": {},
"metadata": [
{
"type": "DDL",
"text": "CREATE FOREIGN TABLE context ( \n \n uid string,\n\n name string options (nameinsource 'name'),\n\n city string options (nameinsource 'city'),\njwt string \n\n) OPTIONS (nameinsource '$.Users[*]', \"plainid:method\" 'GET', \"plainid:URI\" '/users/$(uid)', \"plainid:unwrap\" 'true');"
}
]
}
],
"paasProperties": [
{
"paaId": "PAA3QK1UON1BOXS",
"properties": {
"EndPoint": "http://mockserver.mockserver.svc.cluster.local:1080/json-response",
"Password": null,
"AuthPassword": "plainid",
"SecurityType": "None"
}
}
]
}
```
Expand Allobject sourceIdstring
The parameter is relevent to the Update Sources API. **Omit this parameter from the Create Source API request.**
paaGroupIdstring
adapterstring
namestring
Source Name
statusstring
descriptionstring
Source Description
propertiesobject
translatorobject namestring
typestring
propertiesobject
models Array of object object typestring
modelIdstring
The parameter is relevent to the Update Sources API. **Omit this parameter from the Create Source API request.**
paaGroupIdstring
visibleboolean
namestring
descriptionstring
sourceIds Array of string
This parameter must be `null` in the Create Source API.
string
propertiesobject
metadata Array of object object typestring
textstring
paasProperties Array of object object idstring
The parameter is relevant to the Update Sources API. **Omit this parameter from the Create Source API request.**
sourceIdstring
The parameter is relevant to the Update Sources API. **Omit this parameter from the Create Source API request.**
paaIdstring
The PAA ID. The PAA ID can be found in the Environment or Tenant Settings in the Policy Authorization Agent section.
propertiesobject
Responses201
Source Created
Headersx-request-idstring
Source Created Successfully
```json
{
"data": {
"sourceId": "PIPS4BRPBO81AVPC",
"paaGroupId": "paa1",
"adapter": "ws",
"name": "mockrest2",
"status": "ACTIVE",
"description": "",
"properties": {},
"translator": {
"name": "plainid-rest-iRo",
"type": "plainid-rest",
"properties": {
"supportsfilter": true
}
},
"models": [
{
"type": "PHYSICAL",
"modelId": "PIPMM4BRPBO9U88OW",
"paaGroupId": "paa1",
"visible": true,
"name": "mockrest2",
"description": "",
"sourceIds": [
"PIPS4BRPBO81AVPC"
],
"properties": {},
"metadata": [
{
"type": "DDL",
"text": "CREATE FOREIGN TABLE context ( \n \n uid string,\n\n name string options (nameinsource 'name'),\n\n city string options (nameinsource 'city'),\njwt string \n\n) OPTIONS (nameinsource '$.Users[*]', \"plainid:method\" 'GET', \"plainid:URI\" '/users/$(uid)', \"plainid:unwrap\" 'true');"
}
]
}
],
"paasProperties": [
{
"id": "PIMR4BRPBOE7JUGW",
"sourceId": "PIPS4BRPBO81AVPC",
"paaId": "PAA3QK1UON1BOXS",
"properties": {
"EndPoint": "http://mockserver.mockserver.svc.cluster.local:1080/json-response",
"Password": null,
"AuthPassword": "plainid",
"SecurityType": "None"
}
}
]
}
}
```
Expand Allobject dataobject sourceIdstring
paaGroupIdstring
adapterstring
namestring
statusstring
descriptionstring
propertiesobject
translatorobject namestring
typestring
propertiesobject
models Array of object object typestring
modelIdstring
paaGroupIdstring
visibleboolean
namestring
descriptionstring
sourceIds Array of string string
propertiesobject
metadata Array of object object typestring
textstring
paasProperties Array of object object idstring
sourceIdstring
paaIdstring
propertiesobject
400
Bad Request
Headersx-request-idstring
401
Unauthorized
Headersx-request-idstring
500
Internal Server Error
Headersx-request-idstringThe ID of the request